#include <sys/io.h>
#include <stdio.h>
#include <stdlib.h>

#define DATA	0xf410
void usage(void) {
	fprintf(stderr,
		"Usage: [Command] [Channel]\n"
		"       Command:  O [On], F [oFf], R [Reset], S [Status]\n"
		"       Channel:  1 or 2\n");
	exit(1);
}
int main(int nargs, char **argv) {
	unsigned int val, cur;
	unsigned char channel;
	unsigned long sleeptime;

	if (nargs != 3) {
		usage();
	}
	
	switch(toupper(*argv[1])) {
		case 'O':
			val = 0x01;
			sleeptime = 250000;	/* 0.25 seconds */
			break;
		case 'F':
			val = 0x01;
			sleeptime = 6000000;	/* 4 seconds */
			break;
		case 'R':
			val = 0x02;
			sleeptime = 500000;	/* 0.5 seconds */
			break;
		case 'S':
			val = 0x10;
			break;
		default:
			usage();
	}
	switch(*argv[2]) {
		case '1':
			break;
		case '2':
			if (val > 0x04)
				val <<= 1;
			else
				val <<= 2;
			break;
		default:
			usage();
	}
	
	iopl(3);
	if (toupper(*argv[1]) == 'S') {
		cur = inl(DATA+4);
		fprintf(stderr, "Current status of Channel %c is %s\n",
			*argv[2], (val & cur) ? "Off" : "On");
		exit(0);
	}
	switch (toupper(*argv[1])) {
		case 'O':
			fprintf(stderr, "Turning Channel %c On\n", *argv[2]);
			break;
		case 'F':
			fprintf(stderr, "Turning Channel %c Off\n", *argv[2]);
			break;
		case 'R':
			fprintf(stderr, "Resetting Channel %c\n", *argv[2]);
			break;
	}
	cur = inl(DATA);
	cur &= ~val;		/* Bring bit down to low level */
	outl(cur, DATA);
	usleep(sleeptime);	/* Sleep for the appropriate time */
	outl(cur | val, DATA);	/* Bring bit back to high level */
	return 0;
}

